"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.publicKeyExt = void 0;
const web3_js_1 = require("@solana/web3.js");
const borsh_1 = require("@race-foundation/borsh");
class PublicKeyWriter {
    write(value, buf, offset) {
        buf.set(value.toBytes(), offset);
    }
}
class PublicKeyReader {
    read(buf, offset) {
        const slice = buf.slice(offset, offset + 32);
        return new web3_js_1.PublicKey(slice);
    }
}
exports.publicKeyExt = (0, borsh_1.extend)({
    size: 32,
    writer: new PublicKeyWriter(),
    reader: new PublicKeyReader(),
});
//# sourceMappingURL=utils.js.map