import { PublicKey } from '@solana/web3.js';
import { extend } from '@race-foundation/borsh';
class PublicKeyWriter {
    write(value, buf, offset) {
        buf.set(value.toBytes(), offset);
    }
}
class PublicKeyReader {
    read(buf, offset) {
        const slice = buf.slice(offset, offset + 32);
        return new PublicKey(slice);
    }
}
export const publicKeyExt = extend({
    size: 32,
    writer: new PublicKeyWriter(),
    reader: new PublicKeyReader(),
});
//# sourceMappingURL=utils.js.map